function [D1, D2] = myDPL_ImageLevel(X1, X2, opt)

[d, ~] = size(X1);

dsize = opt.dsize;
lambda1 = opt.lambda1;
lambda2 = opt.lambda2;
lambda3 = opt.lambda3;
gamma = opt.gamma;

%%%--Initialization---%%%
randn('seed',1);
D1 = normcol_equal(randn(d, dsize));
D2 = normcol_equal(randn(d, dsize));
randn('seed',2);
P1 = normcol_equal(randn(dsize, d));
P2 = normcol_equal(randn(dsize, d));

A2 = P2 * X2;

vX11 = inv(X1 * X1' + gamma*eye(d));
vX22 = inv(X2 * X2' + gamma*eye(d));

for loop = 1:opt.iter
    %%%---Update A1, A2---%%%
    A1 = (D1'*D1 + (lambda1+lambda2)*eye(dsize)) \ (D1'*X1 + lambda1*A2 + lambda2*P1*X1);
    A2 = (D2'*D2 + (lambda1+lambda2)*eye(dsize)) \ (D2'*X2 + lambda1*A1 + lambda3*P2*X2);
    
    %%%---Update P1, P2---%%%
    P1 = A1*X1'*vX11;
    P2 = A2*X2'*vX22;
    
    %%%---Update D1, D2---%%%
    [D1] = UpdateD_DPL(A1, X1, D1);
    [D2] = UpdateD_DPL(A2, X2, D2);
    
end
    
    
    
    
    
    
