function [D1, D2, P1, P2] = myDPL_PatchLevel(X1, X2, opt)

[d, ~] = size(X1);

dsize = opt.dsize;
lambda = opt.lambda;
gamma = opt.gamma;

%%%--Initialization---%%%
randn('seed',1);
D1 = normcol_equal(randn(d, dsize));
D2 = D1;
randn('seed',2);
P1 = normcol_equal(randn(dsize, d));
P2 = normcol_equal(randn(dsize, d));

vX11 = inv(X1 * X1' + gamma*eye(d));
vX22 = inv(X2 * X2' + gamma*eye(d));

for loop = 1:opt.iter    
    %%%---Update A1, A2---%%%
    A1 = (D1'*D1 + (lambda)*eye(dsize)) \ (D1'*X1 + lambda*P1*X1);
    A2 = (D2'*D2 + (lambda)*eye(dsize)) \ (D2'*X2 + lambda*P2*X2);
    
    %%%---Update P1, P2---%%%
    P1 = A1*X1'*vX11;
    P2 = A2*X2'*vX22;
    
    %%%---Update D1, D2---%%%
    [D1] = UpdateD_DPL([A1 A2], [X1 X2], D1);
    D2 = D1;
end
    
    
    
    
    
    
